@echo off

echo ------------------------------------------------------------------------------
echo * Network list view switcher for Windows 10                                  *
echo * January 24, 2015                                                           *
echo * Copyright (c) 2015 Ruslan Drinko. All rights reserved.                     *
echo * http://pcportal.org.ru/                                                    *
echo ------------------------------------------------------------------------------

if %PROCESSOR_ARCHITECTURE%==x86 (
set ExeFileName=SetACL.exe
set arch=x86 [32-bit]
)
if %PROCESSOR_ARCHITECTURE%==AMD64 (
set ExeFileName=SetACL64.exe
set arch=x64 [64-bit]
)
Set AdmGroupSID=S-1-5-32-544
Set AdmGroup=
For /F "UseBackQ Tokens=1* Delims==" %%I In (`WMIC Group Where "SID = '%AdmGroupSID%'" Get Name /Value ^| Find "="`) Do Set AdmGroup=%%J
Set AdmGroup=%AdmGroup:~0,-1%
ChCP 866 >nul
set InitialDirectory=%cd%
cd /d "%0\.."

echo Setup is detecting Windows version...
ver | findstr /il "6\.4\." > nul
if %errorlevel% equ 0 (
  echo.
  echo Microsoft Windows 10 %arch% [Version 6.4] detected.
  set WindowsVersion=10
  set RegValue=0x00000000
  goto :BypassVersionError
)
ver | findstr /il "10\.0\.9901" > nul
if %errorlevel% equ 0 (
  echo.
  echo Microsoft Windows 10 %arch% [Version 10.0.9901] detected.
  set WindowsVersion=10
  set RegValue=0x00000000
  goto :BypassVersionError
)
ver | findstr /il "10\.0\." > nul
if %errorlevel% equ 0 (
  echo.
  echo Microsoft Windows 10 %arch% [Version 10.0] detected.
  set WindowsVersion=10
  set RegValue=0x00000002
  goto :BypassVersionError
)
echo.
echo Your Windows version is not supported.
echo This patch must be run only under Microsoft Windows 10.
echo.
pause
exit

:BypassVersionError
echo.
SetACL\%ExeFileName% -on "HKLM\Software\Microsoft\Windows\CurrentVersion\Control Panel\Settings\Network" -ot reg -actn list -lst "f:sddl;w:d,s,o" -bckp "system_policies.bkp"
echo.
SetACL\%ExeFileName% -on "HKLM\Software\Microsoft\Windows\CurrentVersion\Control Panel\Settings\Network" -ot reg -actn setowner -ownr "n:%AdmGroup%"
echo.
SetACL\%ExeFileName% -on "HKLM\Software\Microsoft\Windows\CurrentVersion\Control Panel\Settings\Network" -ot reg -actn ace -ace "n:%AdmGroup%;p:full"
goto :End

:End
set FAQFileName="Windows 10 Help forum.lnk"
xcopy /r /y /h /q %FAQFileName% "%USERPROFILE%\Desktop" > NUL
echo.
echo Write registry data...
echo.
reg add "HKLM\Software\Microsoft\Windows\CurrentVersion\Control Panel\Settings\Network" /v "ReplaceVan" /t REG_DWORD /d %RegValue% /f
echo.
SetACL\%ExeFileName% -on "HKLM\Software\Microsoft\Windows\CurrentVersion\Control Panel\Settings\Network" -ot reg -actn restore -bckp "%cd%\system_policies.bkp"
echo.
del /f /q "%cd%\system_policies.bkp" > NUL
pause
exit